//===========================================================================
//  Trubetskoy Alex,  April 2004
//===========================================================================
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#pragma hdrstop
#include "tcp.h"
//---------------------------------------------------------------------------

int main() {
    sockaddr_in serverAddr;       // server's socket address
    sockaddr_in clientAddr;       // client's socket address
    int sockAddrSize;             // size of socket address structure
    SOCKET sHandle;               // socket file descriptor
    SOCKET newSHandle;            // socket descriptor from accept
    WSADATA wsaData;      //data structure that is to receive details
                          //of the Windows Sockets implementation
    int nbyte = 0;        //number of sended bytes

    char clientRequest[REQUEST_MSG_SIZE];

    // set up the local address
    sockAddrSize = sizeof(sockaddr_in);
    memset(&serverAddr, 0, sockAddrSize);
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_port = htons(SERVER_PORT_NUM);
    serverAddr.sin_addr.s_addr = INADDR_ANY;

    // initiate use of WS2_32.DLL by a process
    if(WSAStartup(MAKEWORD(1, 1), &wsaData)) {
        getSocketError();
        getch();
        return 0;
    }

    // create a TCP-based socket
    if((sHandle = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) {
        getSocketError();
        getch();
        return 0;
    }

    // bind socket to local address
    if(bind(sHandle, (sockaddr *)&serverAddr,
            sockAddrSize)  == -1 )
    {
        getSocketError();
        closesocket(sHandle);
        getch();
        return 0;
    } 

    // create queue for client connection requests
    if(listen(sHandle, SERVER_MAX_CONNECTIONS) == -1) {
        getSocketError();
        closesocket(sHandle);
        getch();
        return 0;
    }

    // accept new connect requests and spawn tasks to process them
    // Note: newSHandle socket will take propreties of
    // sHandle socket
    if((newSHandle = accept(sHandle,
                              (sockaddr *)&clientAddr,
                              &sockAddrSize)) == INVALID_SOCKET)
    {
        getSocketError();
        closesocket(sHandle);
        getch();
        return 0;
    }

    nbyte = recv(newSHandle, (char *)clientRequest,
                 sizeof(clientRequest), MSG_PEEK);
    if (nbyte != SOCKET_ERROR) {
        printf("Have received %d bytes \n", nbyte);
        printf("Data: %s\n", clientRequest);
    }
    else
       getSocketError();

    memset(clientRequest, 0, REQUEST_MSG_SIZE);
    closesocket(sHandle);
    closesocket(newSHandle);
    printf("Press any key\n");
    getch();
    return 0;
}
//---------------------------------------------------------------------------

void getSocketError() {
   LPVOID lpMsgBuf;
   if (!FormatMessage(
       FORMAT_MESSAGE_ALLOCATE_BUFFER |
       FORMAT_MESSAGE_FROM_SYSTEM |
       FORMAT_MESSAGE_IGNORE_INSERTS,
       NULL,
       GetLastError(),
       MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
       (LPTSTR) &lpMsgBuf,
       0,
       NULL))
   {
      MessageBox(NULL, "Error number not found",
                 "Error", MB_OK | MB_ICONSTOP);
      return;
   }

   // Display the string.
   MessageBox(NULL, (LPCTSTR)lpMsgBuf, "Error",
               MB_OK | MB_ICONSTOP);

   // Free the buffer.
   LocalFree(lpMsgBuf);
}
//---------------------------------------------------------------------------
