//===========================================================================
//  Trubetskoy Alex,  April 2004
//===========================================================================
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#pragma hdrstop
#include "tcp.h"
//---------------------------------------------------------------------------

// 
double ctime() {
    SYSTEMTIME time;
    GetSystemTime(&time);
    return ((double)time.wSecond + (double)time.wMilliseconds * 1.0e-3);
}
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[]) {
    char clientRequest[REQUEST_MSG_SIZE];
    sockaddr_in  serverAddr;     //server's socket address
    int sockAddrSize;            //size of socket address structure
    SOCKET sHandle;              //socket descriptor
    unsigned nbyte;
    double starttime, endtime;
    unsigned mlen;
    char* serverName;
    WSADATA wsaData;           //data structure that is to receive
                               //details of the Windows Sockets implementation

    serverName = argv[1];

    //initiate use of WS2_32.DLL by a process
    if(WSAStartup(MAKEWORD(1, 1), &wsaData)) {
        getSocketError();
        printf("Press any key\n"); getch();
        return 0;
    }

    //create client's socket
    if((sHandle = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) {
        getSocketError();
        printf("Press any key\n"); getch();
        return 0;
    }

    // bind not required - port number is dynamic

    // build server socket address
    sockAddrSize = sizeof(sockaddr_in);
    memset(&serverAddr, 0, sockAddrSize);
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_port = htons(SERVER_PORT_NUM);

    if((serverAddr.sin_addr.s_addr = inet_addr(serverName)) == INADDR_NONE) {
        perror("unknown server name");
        closesocket(sHandle);
        printf("Press any key\n"); getch();
        return 0;
    }

    //connect to server
    if(connect(sHandle, (sockaddr *)&serverAddr,
                 sockAddrSize) == -1)
    {
        getSocketError();
        closesocket(sHandle);
        printf("Press any key\n"); getch();
        return 0;
    }

    //fill string to send
    printf("Introduce the string to send:\n");
    gets(clientRequest);
    mlen = strlen(clientRequest);
    if(mlen >= REQUEST_MSG_SIZE) {
        printf("Max length of message is %d bytes !\n", REQUEST_MSG_SIZE-1);
        printf("Press any key\n"); getch();
        return 0;
    }

    //send request to server
    starttime = ctime();
    if((nbyte = send(sHandle, (char *)clientRequest,
                  mlen, MSG_DONTROUTE)) == SOCKET_ERROR)
    {
       getSocketError();
       closesocket(sHandle);
       printf("Press any key\n"); getch();
       return 0;
    }

    if(nbyte != mlen)
          printf("Write only %d (%d) bytes\n", nbyte, mlen);

    endtime = ctime() - starttime;
    printf("send_time = %f\n", (float)endtime);
    closesocket(sHandle);
    
    printf("Press any key\n");
    getch();
    return 0;
}

//---------------------------------------------------------------------------

void getSocketError() {
   LPVOID lpMsgBuf;
   if (!FormatMessage(
       FORMAT_MESSAGE_ALLOCATE_BUFFER |
       FORMAT_MESSAGE_FROM_SYSTEM |
       FORMAT_MESSAGE_IGNORE_INSERTS,
       NULL,
       GetLastError(),
       MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
       (LPTSTR) &lpMsgBuf,
       0,
       NULL ))
   {
      MessageBox(NULL, "Error number not found",
                 "Error", MB_OK | MB_ICONSTOP );
      return;
   }

   // Display the string.
   MessageBox(NULL, (LPCTSTR)lpMsgBuf, "Error",
               MB_OK | MB_ICONSTOP);

   // Free the buffer.
   LocalFree(lpMsgBuf);
}
//---------------------------------------------------------------------------